> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://help.sigmacomputing.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://help.sigmacomputing.com/_mcp/server.

# List lineage for a workbook

GET https://api.sigmacomputing.com/v2/workbooks/{workbookId}/lineage

This endpoint lists the elements, data sources, and upstream lineage for those data sources in a workbook, providing a detailed view of how data is interconnected within a workbook.

  ### Usage notes
  - Retrieve the **workbookId** by calling the [/v2/workbooks](https://help.sigmacomputing.com/reference/list-workbooks) endpoint.

  ### Usage scenarios
  - **Data governance:** Allows data managers to track how information is used and propagated through different workbook elements.
  - **Debugging and optimization:** Helps with identifying and resolving issues in data processing or workbook structure.
  - **Data source management**: Identify the dependencies of data sources in use in a specific workbook.

  ### Best practices
  - Integrate this information into documentation or data dictionaries to enhance transparency and understanding across teams.
  - Use this endpoint to regularly audit workbook structures, ensuring that all data connections and transformations are correct and optimized.

Reference: https://help.sigmacomputing.com/reference/list-lineage-tree

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: sigma-rest-api
  version: 1.0.0
paths:
  /v2/workbooks/{workbookId}/lineage:
    get:
      operationId: listLineageTree
      summary: List lineage for a workbook
      description: >-
        This endpoint lists the elements, data sources, and upstream lineage for
        those data sources in a workbook, providing a detailed view of how data
        is interconnected within a workbook.

          ### Usage notes
          - Retrieve the **workbookId** by calling the [/v2/workbooks](https://help.sigmacomputing.com/reference/list-workbooks) endpoint.

          ### Usage scenarios
          - **Data governance:** Allows data managers to track how information is used and propagated through different workbook elements.
          - **Debugging and optimization:** Helps with identifying and resolving issues in data processing or workbook structure.
          - **Data source management**: Identify the dependencies of data sources in use in a specific workbook.

          ### Best practices
          - Integrate this information into documentation or data dictionaries to enhance transparency and understanding across teams.
          - Use this endpoint to regularly audit workbook structures, ensuring that all data connections and transformations are correct and optimized.
      tags:
        - Workbooks
      parameters:
        - name: workbookId
          in: path
          required: true
          schema:
            type: string
        - name: page
          in: query
          required: false
          schema:
            type: string
        - name: limit
          in: query
          required: false
          schema:
            type: number
            format: double
        - name: Authorization
          in: header
          description: OAuth authentication
          required: true
          schema:
            type: string
      responses:
        '200':
          description: The response body.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/workbooks_listLineageTree_Response_200'
servers:
  - url: https://api.sigmacomputing.com
    description: Server for GCP (US) hosted organizations
  - url: https://api.sa.gcp.sigmacomputing.com
    description: Server for GCP (KSA) hosted organizations
  - url: https://aws-api.sigmacomputing.com
    description: Server for AWS US (West) hosted organizations
  - url: https://api.us-a.aws.sigmacomputing.com
    description: Server for AWS US (East) hosted organizations
  - url: https://api.ca.aws.sigmacomputing.com
    description: Server for AWS Canada hosted organizations
  - url: https://api.eu.aws.sigmacomputing.com
    description: Server for AWS Europe hosted organizations
  - url: https://api.au.aws.sigmacomputing.com
    description: Server for AWS Australia and APAC hosted organizations
  - url: https://api.uk.aws.sigmacomputing.com
    description: Server for AWS UK hosted organizations
  - url: https://api.us.azure.sigmacomputing.com
    description: Server for Azure US hosted organizations
  - url: https://api.eu.azure.sigmacomputing.com
    description: Server for Azure Europe hosted organizations
  - url: https://api.ca.azure.sigmacomputing.com
    description: Server for Azure Canada hosted organizations
  - url: https://api.uk.azure.sigmacomputing.com
    description: Server for Azure United Kingdom hosted organizations
  - url: https://api.au.azure.sigmacomputing.com
    description: Server for Azure Australia hosted organizations
components:
  schemas:
    V2WorkbooksWorkbookIdLineageGetResponsesContentApplicationJsonSchemaEntriesItemsOneOf0Type:
      type: string
      enum:
        - table
        - dataset
        - data-model
        - element
        - customSQL
        - csv-upload
      title: >-
        V2WorkbooksWorkbookIdLineageGetResponsesContentApplicationJsonSchemaEntriesItemsOneOf0Type
    V2WorkbooksWorkbookIdLineageGetResponsesContentApplicationJsonSchemaEntriesItems0:
      type: object
      properties:
        type:
          $ref: >-
            #/components/schemas/V2WorkbooksWorkbookIdLineageGetResponsesContentApplicationJsonSchemaEntriesItemsOneOf0Type
        sourceIds:
          type:
            - array
            - 'null'
          items:
            type: string
          description: >-
            List of direct sources for the element. Either element IDs or data
            source IDs.
        elementId:
          type: string
          description: Unique identifier of the element
        dataSourceIds:
          type:
            - array
            - 'null'
          items:
            type: string
          description: List of root sources for the element as data source IDs.
      required:
        - type
        - sourceIds
        - elementId
        - dataSourceIds
      title: >-
        V2WorkbooksWorkbookIdLineageGetResponsesContentApplicationJsonSchemaEntriesItems0
    V2WorkbooksWorkbookIdLineageGetResponsesContentApplicationJsonSchemaEntriesItemsOneOf1Type:
      type: string
      enum:
        - table
        - dataset
        - data-model
        - element
        - customSQL
        - csv-upload
      title: >-
        V2WorkbooksWorkbookIdLineageGetResponsesContentApplicationJsonSchemaEntriesItemsOneOf1Type
    V2WorkbooksWorkbookIdLineageGetResponsesContentApplicationJsonSchemaEntriesItems1:
      type: object
      properties:
        type:
          $ref: >-
            #/components/schemas/V2WorkbooksWorkbookIdLineageGetResponsesContentApplicationJsonSchemaEntriesItemsOneOf1Type
        connectionId:
          type:
            - string
            - 'null'
        name:
          type:
            - string
            - 'null'
        dataModelId:
          type: string
      required:
        - type
        - connectionId
        - name
        - dataModelId
      title: >-
        V2WorkbooksWorkbookIdLineageGetResponsesContentApplicationJsonSchemaEntriesItems1
    V2WorkbooksWorkbookIdLineageGetResponsesContentApplicationJsonSchemaEntriesItemsOneOf2Type:
      type: string
      enum:
        - table
        - dataset
        - data-model
        - element
        - customSQL
        - csv-upload
      title: >-
        V2WorkbooksWorkbookIdLineageGetResponsesContentApplicationJsonSchemaEntriesItemsOneOf2Type
    V2WorkbooksWorkbookIdLineageGetResponsesContentApplicationJsonSchemaEntriesItems2:
      type: object
      properties:
        type:
          $ref: >-
            #/components/schemas/V2WorkbooksWorkbookIdLineageGetResponsesContentApplicationJsonSchemaEntriesItemsOneOf2Type
        connectionId:
          type:
            - string
            - 'null'
        name:
          type:
            - string
            - 'null'
        inodeId:
          type: string
      required:
        - type
        - connectionId
        - name
        - inodeId
      title: >-
        V2WorkbooksWorkbookIdLineageGetResponsesContentApplicationJsonSchemaEntriesItems2
    V2WorkbooksWorkbookIdLineageGetResponsesContentApplicationJsonSchemaEntriesItemsOneOf3Type:
      type: string
      enum:
        - table
        - dataset
        - data-model
        - element
        - customSQL
        - csv-upload
      title: >-
        V2WorkbooksWorkbookIdLineageGetResponsesContentApplicationJsonSchemaEntriesItemsOneOf3Type
    V2WorkbooksWorkbookIdLineageGetResponsesContentApplicationJsonSchemaEntriesItems3:
      type: object
      properties:
        type:
          $ref: >-
            #/components/schemas/V2WorkbooksWorkbookIdLineageGetResponsesContentApplicationJsonSchemaEntriesItemsOneOf3Type
        connectionId:
          type:
            - string
            - 'null'
        name:
          type:
            - string
            - 'null'
        definition:
          type: string
      required:
        - type
        - connectionId
        - name
        - definition
      title: >-
        V2WorkbooksWorkbookIdLineageGetResponsesContentApplicationJsonSchemaEntriesItems3
    V2WorkbooksWorkbookIdLineageGetResponsesContentApplicationJsonSchemaEntriesItemsOneOf4Type:
      type: string
      enum:
        - table
        - dataset
        - data-model
        - element
        - customSQL
        - csv-upload
      title: >-
        V2WorkbooksWorkbookIdLineageGetResponsesContentApplicationJsonSchemaEntriesItemsOneOf4Type
    V2WorkbooksWorkbookIdLineageGetResponsesContentApplicationJsonSchemaEntriesItems4:
      type: object
      properties:
        type:
          $ref: >-
            #/components/schemas/V2WorkbooksWorkbookIdLineageGetResponsesContentApplicationJsonSchemaEntriesItemsOneOf4Type
        connectionId:
          type:
            - string
            - 'null'
        name:
          type:
            - string
            - 'null'
        csvId:
          type: string
          description: Unique identifier of the uploaded CSV file
      required:
        - type
        - connectionId
        - name
        - csvId
      title: >-
        V2WorkbooksWorkbookIdLineageGetResponsesContentApplicationJsonSchemaEntriesItems4
    V2WorkbooksWorkbookIdLineageGetResponsesContentApplicationJsonSchemaEntriesItems:
      oneOf:
        - $ref: >-
            #/components/schemas/V2WorkbooksWorkbookIdLineageGetResponsesContentApplicationJsonSchemaEntriesItems0
        - $ref: >-
            #/components/schemas/V2WorkbooksWorkbookIdLineageGetResponsesContentApplicationJsonSchemaEntriesItems1
        - $ref: >-
            #/components/schemas/V2WorkbooksWorkbookIdLineageGetResponsesContentApplicationJsonSchemaEntriesItems2
        - $ref: >-
            #/components/schemas/V2WorkbooksWorkbookIdLineageGetResponsesContentApplicationJsonSchemaEntriesItems3
        - $ref: >-
            #/components/schemas/V2WorkbooksWorkbookIdLineageGetResponsesContentApplicationJsonSchemaEntriesItems4
      title: >-
        V2WorkbooksWorkbookIdLineageGetResponsesContentApplicationJsonSchemaEntriesItems
    workbooks_listLineageTree_Response_200:
      type: object
      properties:
        entries:
          type: array
          items:
            $ref: >-
              #/components/schemas/V2WorkbooksWorkbookIdLineageGetResponsesContentApplicationJsonSchemaEntriesItems
        nextPage:
          type:
            - string
            - 'null'
        total:
          type: number
          format: double
      required:
        - entries
        - nextPage
      title: workbooks_listLineageTree_Response_200
  securitySchemes:
    OAuth:
      type: http
      scheme: bearer
      description: OAuth 2.0 authentication

```

## Examples



**Response**

```json
{
  "entries": [
    {
      "dataSourceIds": [
        "QzcnTZrK9y8TjZs0T6OKO/En4r45kOFn"
      ],
      "elementId": "5AbJJlOiPPtgpL3cCk7GqA",
      "sourceIds": [
        "QzcnTZrK9y8TjZs0T6OKO"
      ],
      "type": "element"
    },
    {
      "dataSourceIds": [
        "QzcnTZrK9y8TjZs0T6OKO/En4r45kOFn"
      ],
      "elementId": "5AbJJlOiPPtgpL3cCk7GqA",
      "sourceIds": [
        "4ZJD7G8AR03qf2oySPwoc3"
      ],
      "type": "element"
    },
    {
      "dataSourceIds": [
        "QzcnTZrK9y8TjZs0T6OKO/En4r45kOFn",
        "d5a56ed4-16bf-4de3-be32-e0738f31be42"
      ],
      "elementId": "3fqWi0z9SWwxuilnuq8w34",
      "sourceIds": [
        "2MLjb1f67ldr3FMNI2L6Pf",
        "4ZJD7G8AR03qf2oySPwoc3"
      ],
      "type": "element"
    },
    {
      "connectionId": "dd76be0a-08bc-4c88-8a79-9956f933e701",
      "dataModelId": "d5a56ed4-16bf-4de3-be32-e0738f31be42",
      "dataSourceIds": [
        "string"
      ],
      "datasourceId": "QzcnTZrK9y8TjZs0T6OKO/En4r45kOFn",
      "elementId": "string",
      "sourceIds": [
        "string"
      ],
      "type": "data-model"
    },
    {
      "connectionId": "dd76be0a-08bc-4c88-8a79-9956f933e701",
      "dataSourceIds": [
        "string"
      ],
      "datasourceId": "d5a56ed4-16bf-4de3-be32-e0738f31be42",
      "elementId": "string",
      "inodeId": "eef50bc2-16c5-44ee-a913-9ae9d95e5295",
      "inodeName": "DOCKS",
      "sourceIds": [
        "string"
      ],
      "type": "table"
    }
  ],
  "nextPage": null
}
```

**SDK Code**

```python Response Example
import requests

url = "https://api.sigmacomputing.com/v2/workbooks/workbookId/lineage"

headers = {"Authorization": "<token>."}

response = requests.get(url, headers=headers)

print(response.json())
```

```javascript Response Example
const url = 'https://api.sigmacomputing.com/v2/workbooks/workbookId/lineage';
const options = {method: 'GET', headers: {Authorization: '<token>.'}};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go Response Example
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://api.sigmacomputing.com/v2/workbooks/workbookId/lineage"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("Authorization", "<token>.")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Response Example
require 'uri'
require 'net/http'

url = URI("https://api.sigmacomputing.com/v2/workbooks/workbookId/lineage")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = '<token>.'

response = http.request(request)
puts response.read_body
```

```java Response Example
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://api.sigmacomputing.com/v2/workbooks/workbookId/lineage")
  .header("Authorization", "<token>.")
  .asString();
```

```php Response Example
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://api.sigmacomputing.com/v2/workbooks/workbookId/lineage', [
  'headers' => [
    'Authorization' => '<token>.',
  ],
]);

echo $response->getBody();
```

```csharp Response Example
using RestSharp;

var client = new RestClient("https://api.sigmacomputing.com/v2/workbooks/workbookId/lineage");
var request = new RestRequest(Method.GET);
request.AddHeader("Authorization", "<token>.");
IRestResponse response = client.Execute(request);
```

```swift Response Example
import Foundation

let headers = ["Authorization": "<token>."]

let request = NSMutableURLRequest(url: NSURL(string: "https://api.sigmacomputing.com/v2/workbooks/workbookId/lineage")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```